/**
 * @(#) Engine.java
 */

package com.softsky.transj.translator;

import org.eclipse.swt.widgets.Display;
import com.softsky.transj.ui.swt.Options;

public class Engine
{
   
    private Display display;
    
    private ITranslator translator;
    private Options options;
    
    /**
     * Creates translation Engine, initialized needed elements
     */
    public Engine( Display display, ITranslator translator )
    {
        this.display = display;
        this.translator = translator;
    }
    
    /**
     * Performs asynchronous translation on given string in given direction. translationCallback should not be null. Raise NullPointer exception if translationCallbakc is null.
     */
    public void translate( Direction direction, Options options, String text, ITranslationCallback translationCallback )
    {
        display.asyncExec(new TranslationProcess(translationCallback, translator, options, direction, text));
    }
    
}
