/**
 * @(#) ITranslationCallback.java
 */

package com.softsky.transj.translator;

/**
 * Public interface describes call back mechanism for threaded translation. Used by TranslationProcess class. Top-level handlers should use (realize) that interface to get notification about translation process has been fininshed.
 */
public abstract interface ITranslationCallback
{
    /**
     * Method is called by TranslationProcess class once translation has been finished.
     */
    void translationDone( TranslationResult translationResult );  
    
}
