/**
 * @(#) ITranslator.java
 */

package com.softsky.transj.translator;

import com.softsky.transj.IExceptionHandler;
/**
 * Public Interface describes any Translator. All translators should realize that interface.
 */
public abstract interface ITranslator {
    /**
     * Perform translation on given text in given direction.
     */
    String translate( Direction direction, String text, boolean rememberText, int connectionTimeout);
    Direction[] getSupportedDirections( );
    public void setExceptionHandler(IExceptionHandler exceptionHandler);
    public void clearCache();
    
}
