/**
 * @(#) TranslationProcess.java
 */

package com.softsky.transj.translator;

import com.softsky.transj.ui.swt.Options;
/**
 * Class performs thread-based translation.
 */
public class TranslationProcess implements Runnable {
    private Options options;
    /**
     * Local copy of ITranslationCallback object, notification about translation complete will be sent to.
     */
    private ITranslationCallback callback;
    
    /**
     * Local copy of ITranslator which will perform translation.
     */
    private ITranslator translator;
    
    /**
     * Local copy of Direction in which tranlslation will be performed. Passed to Translator.
     */
    private Direction direction;
    
    /**
     * Local copy of Text which should be translated. Passed to Translator.
     */
    private String text;
    
    /**
     * Runs translation process. Once it's done, creates TransactionResult object, use callback mechanism with passed TranslationResult object to notify caller about trabslation is done.
     */
    public void run( ) {
        String result = this.translator.translate(direction, text, options.isRememberText(), options.getTimeout());
        callback.translationDone(new TranslationResult(result));
    }
    
    
    /**
     * Creates TranslationProcess object.
     */
    public TranslationProcess( ITranslationCallback callback, ITranslator translator, Options options, Direction direction, String text) {
        this.callback = callback;
        this.translator = translator;
        this.direction = direction;
        this.text = text;
        this.options = options;
    }
    
}
