/**
 * @(#) TranslationResult.java
 */

package com.softsky.transj.translator;


/**
 * Result of the translation.
 */
public class TranslationResult {
    
    
    /**
     * Resut of the translation.
     */
    private String text;
    
    
    /**
     * Translation error has been occured.
     */
    public static final short TRANSLATION_ERROR = 1;
    
    
    /**
     * Translation succesfully finished.
     */
    public static final short TRANSLATION_SUCCESS = 0;
    
    
    /**
     * Translation status.
     * Possible values:
     * TRANSLATION_ERROR, TRANSLATION_SUCCESS.
     */
    private short error;
    
    /**
     * Overloads Object.toString() method. Returns string representation of translated words.
     */
    public String toString( ) {
        if(text != null)
            return text.toString();
        else
            return "";
    }
    
    /**
     * Getter for property error.
     * @return Value of property error.
     */
    public short getError() {
        return error;
    }    
    
    /**
     * Constructs TranslationResult object. If text parameter is not null, TRANSLATION_SUCCESS is assigned to error attribute. Otherwise TRANSLATION_ERROR is assigned to error attribute and text attribute is null.
     */
    public TranslationResult( String text ) {
        if((this.text = text) == null)
            error = TranslationResult.TRANSLATION_ERROR;
        else
            error = TranslationResult.TRANSLATION_SUCCESS;
    }
    
    
    
}
