package com.softsky.transj.ui.swt;

import java.io.InputStream;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.SWT;

import java.io.*;
import com.softsky.transj.*;

public class About {
    // START VISUALS_DECLARATION
    private Display display = null;
    private TabItem TabItem_1 = null;
    private TabItem TabItem_2 = null;
    private TabFolder TabFolder_1 = null;
    private Label Label_1 = null;
    private Composite Composite_2 = null;
    private Text Text_1 = null;
    private Shell shell = null;
    private TabItem TabItem_3 = null;
    private Composite Composite_3 = null;
    private Composite Composite_1 = null;
    // END VISUALS_DECLARATION
    
    private IExceptionHandler exceptionHandler = null;
    private Shell parent;
    
    private void createControls() {
        // START VISUALS_INITIALIZATION
        // init visuals
        display = Display.getDefault();
        shell = new Shell(parent, SWT.MODELESS | SWT.SHELL_TRIM);
        TabFolder_1 = new TabFolder(shell, SWT.NULL);
        TabItem_1 = new TabItem(TabFolder_1, SWT.DEFAULT);
        Composite_1 = new Composite(TabFolder_1, SWT.BORDER | SWT.NULL);
        Composite_2 = new Composite(Composite_1, SWT.NULL);
        Label_1 = new Label(Composite_2, SWT.CENTER | SWT.VERTICAL);
        TabItem_2 = new TabItem(TabFolder_1, SWT.NULL);
        TabItem_3 = new TabItem(TabFolder_1, SWT.NULL);
        Composite_3 = new Composite(TabFolder_1, SWT.NULL);
        Text_1 = new Text(Composite_3, SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.VERTICAL | SWT.HORIZONTAL);
        
        // set properties
        shell.setText("About TransJ");
        shell.setBounds(new Rectangle(402, 623, 329, 266));
        TabItem_1.setText("About");
        TabItem_1.setControl(Composite_1);
        Label_1.setLayoutData(new GridData());
        Label_1.setText("TransJ is open source desktop translation tool");
        TabItem_2.setText("Credits");
        TabItem_3.setText("License Agreement");
        TabItem_3.setControl(Composite_3);
        Text_1.setText("Text_1");
        Composite_3.setLayout(new FillLayout());
        Composite_2.setLayout(new GridLayout());
        Composite_1.setLayout(new FillLayout());
        shell.setLayout(new FillLayout());
        shell.setVisible(true);
        // END VISUALS_INITIALIZATION
        
        // START EVENT_INITIALIZATION
        // END EVENT_INITIALIZATION
    }
    
    // START EVENT_HANDLING
    private InputStream getImageResourceAsStream(String name) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    // END EVENT_HANDLING
    
    public About(Shell parent, IExceptionHandler exceptionHandler) {
        this.parent = parent;
        this.exceptionHandler = exceptionHandler;
        createControls();
        loadLicenseText();
    }
    
    private void loadLicenseText(){
        StringBuffer license = new StringBuffer();
        try{
            //String curDir = System.getProperty("user.dir");
            String curDir = "/home/archer/workspace/TransJ";
            BufferedReader reader = new BufferedReader(new FileReader(curDir + "/COPYING"));
            String line = null;
            while((line = reader.readLine()) != null)
                license.append(line + "\n");
            
            Text_1.setText(license.toString());
                
        }catch(FileNotFoundException e) {
            exceptionHandler.handleException(e);
        }catch(IOException e) {
            exceptionHandler.handleException(e);
        }
    }
    
    public void open(){
        shell.layout();
        shell.open();
    }
}
