package com.softsky.transj.ui.swt;
import java.io.InputStream;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

public class ExceptionWindow {
    // START VISUALS_DECLARATION
    private Text lStacktrace = null;
    private Button btnMore = null;
    private Button btnClose = null;
    private Label lExceptionText = null;
    private Shell parent = null;
    private Shell shell = null;
    private Display Display_1 = null;
    // END VISUALS_DECLARATION
    
    private Exception exception;
    
    private void createControls() {
        // START VISUALS_INITIALIZATION
        // init visuals
        shell = new Shell(parent, SWT.SHELL_TRIM);
        lExceptionText = new Label(shell, SWT.LEFT | SWT.BORDER);
        btnClose = new Button(shell, SWT.PUSH);
        btnMore = new Button(shell, SWT.PUSH);
        lStacktrace = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.H_SCROLL | SWT.LEFT | SWT.READ_ONLY | SWT.V_SCROLL | SWT.WRAP);
        
        // init nonviusuals
        GridData GridData_2 = new GridData();
        GridData GridData_1 = new GridData();
        GridData GridData_3 = new GridData();
        GridData GridData_4 = new GridData();
        GridLayout GridLayout_1 = new GridLayout();
        
        // set fields
        GridData_2.verticalSpan = 2;
        GridData_2.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_2.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_2.grabExcessVerticalSpace = false;
        GridData_2.grabExcessHorizontalSpace = true;
        GridData_2.widthHint = 400;
        GridData_2.heightHint = 50;
        GridData_1.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_1.verticalAlignment = org.eclipse.swt.layout.GridData.BEGINNING;
        GridData_3.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_3.verticalAlignment = org.eclipse.swt.layout.GridData.BEGINNING;
        
        GridData_4.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_4.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_4.grabExcessVerticalSpace = true;
        GridData_4.horizontalSpan = 2;
        GridData_4.heightHint = 400;
        GridLayout_1.numColumns = 2;
        
        lStacktrace.setBackground(new Color(Display.getDefault(), new RGB(200, 200, 200)));
        // set properties
        shell.setText("Exception occured");
        shell.setBounds(new Rectangle(402, 439, 407, 342));
        lExceptionText.setLayoutData(GridData_2);
        btnClose.setLayoutData(GridData_1);
        btnClose.setText("Close");
        btnClose.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                shell.close();
            }
            
        });
        btnMore.setLayoutData(GridData_3);
        btnMore.setText("More >>");
        btnMore.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                ByteArrayOutputStream os = new ByteArrayOutputStream(4096);
                exception.printStackTrace(new PrintStream(os));
                lStacktrace.setText(new String(os.toByteArray()));

                lStacktrace.setVisible(true);
                btnMore.setEnabled(false);
                shell.layout();
            }
            
        });
        lStacktrace.setLayoutData(GridData_4);
        lStacktrace.setVisible(false);
        shell.setLayout(GridLayout_1);
        //shell.setVisible(true);
        // END VISUALS_INITIALIZATION
        
        // START EVENT_INITIALIZATION
        // END EVENT_INITIALIZATION
    }
    
    // START EVENT_HANDLING
    private InputStream getImageResourceAsStream(String name) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    // END EVENT_HANDLING
    
    public ExceptionWindow(Shell parent, Exception e) {
        this.parent = parent;
        createControls();
        this.exception = e;
        lExceptionText.setText(e.toString());
    }
    public void open() {
        shell.pack();
        shell.open();
    }
}
