package com.softsky.transj.ui.swt;
import java.io.InputStream;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.SWT;

public class GeneralSettings {
    // START VISUALS_DECLARATION
    private Button chkRemmember = null;
    private Table tablePlugins = null;
    private Group gPlugins = null;
    private Label lActivate = null;
    private Group gOptions = null;
    private TableColumn colPlugins = null;
    private FileDialog dlgFile = null;
    private Text edTimeout = null;
    private Text edBrowserLaunch = null;
    private Button chkScanAndReverse = null;
    private Button btnAdd = null;
    private Button chkInformDevelopers = null;
    private Composite panPluginButtons = null;
    private Label lTimeout = null;
    private Label lCommand = null;
    private Button btnRemove = null;
    
    
    // END VISUALS_DECLARATION
    
    private void createControls(Composite parent) {
        // START VISUALS_INITIALIZATION
        // init visuals
        gOptions = new Group(parent, SWT.SHADOW_OUT | SWT.NULL);
        chkRemmember = new Button(gOptions, SWT.CHECK);
        chkScanAndReverse = new Button(gOptions, SWT.CHECK);
        chkInformDevelopers = new Button(gOptions, SWT.CHECK);
        lTimeout = new Label(gOptions, SWT.CENTER);
        edTimeout = new Text(gOptions, SWT.BORDER);
        lCommand = new Label(gOptions, SWT.CENTER);
        edBrowserLaunch = new Text(gOptions, SWT.BORDER);
        gPlugins = new Group(parent, SWT.SHADOW_OUT | SWT.NULL);
        lActivate = new Label(gPlugins, SWT.CENTER);
        tablePlugins = new Table(gPlugins, SWT.SINGLE | SWT.BORDER | SWT.CHECK);
        colPlugins = new TableColumn(tablePlugins, SWT.LEFT);
        panPluginButtons = new Composite(gPlugins, SWT.NULL);
        btnAdd = new Button(panPluginButtons, SWT.PUSH);
        btnRemove = new Button(panPluginButtons, SWT.PUSH);
        
        // init nonviusuals
        GridData GridData_2 = new GridData();
        GridData GridData_3 = new GridData();
        GridData GridData_6 = new GridData();
        GridData GridData_4 = new GridData();
        GridData GridData_44 = new GridData();
        GridData GridData_5 = new GridData();
        GridData GridData_55 = new GridData();
        GridData GridData_1 = new GridData();
        GridLayout GridLayout_2 = new GridLayout();
        GridData GridData_12 = new GridData();
        GridData GridData_8 = new GridData();
        GridData GridData_9 = new GridData();
        GridData GridData_10 = new GridData();
        GridLayout GridLayout_4 = new GridLayout();
        GridData GridData_7 = new GridData();
        GridLayout GridLayout_3 = new GridLayout();
        //dlgFile = new FileDialog(null, SWT.MULTI);
        
        // set fields
        GridData_2.horizontalSpan = 2;
        GridData_3.horizontalSpan = 2;
        GridData_6.horizontalSpan = 2;
        GridData_4.grabExcessHorizontalSpace = false;
        GridData_44.grabExcessHorizontalSpace = false;
        GridData_5.widthHint = 50;
        //GridData_55.widthHint = 150;
        GridData_55.grabExcessHorizontalSpace = true;
        GridData_55.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        
        GridData_1.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_1.grabExcessHorizontalSpace = true;
        GridLayout_2.numColumns = 2;
        GridData_12.horizontalAlignment = org.eclipse.swt.layout.GridData.BEGINNING;
        GridData_12.horizontalSpan = 1;
        GridData_12.grabExcessHorizontalSpace = true;
        GridData_8.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_8.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_8.grabExcessVerticalSpace = true;
        GridData_8.horizontalSpan = 1;
        GridData_8.grabExcessHorizontalSpace = true;
        GridData_9.horizontalAlignment = org.eclipse.swt.layout.GridData.END;
        GridData_9.grabExcessHorizontalSpace = true;
        GridData_9.widthHint = 75;
        GridData_10.horizontalAlignment = org.eclipse.swt.layout.GridData.END;
        GridData_10.grabExcessHorizontalSpace = true;
        GridData_10.widthHint = 75;
        GridLayout_4.numColumns = 2;
        GridData_7.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_7.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_7.grabExcessVerticalSpace = true;
        GridData_7.grabExcessHorizontalSpace = true;
        GridLayout_3.numColumns = 1;
        
        // set properties
        //dlgFile.setText("Open plugin file");
        //parent.setBounds(new Rectangle(402, 439, 533, 464));
        gOptions.setLayoutData(GridData_1);
        gOptions.setText(" Translation options ");
        chkRemmember.setLayoutData(GridData_2);
        chkRemmember.setText("Remember text already translated");
        chkScanAndReverse.setLayoutData(GridData_3);
        chkScanAndReverse.setText("Scan and reverse languages if needed");
        chkInformDevelopers.setLayoutData(GridData_6);
        chkInformDevelopers.setText("Send developer all errors");
        chkInformDevelopers.setEnabled(false);
        lTimeout.setLayoutData(GridData_4);
        lTimeout.setText("Connection timeout (sec)");
        
        edTimeout.setTextLimit(3);
        edTimeout.setLayoutData(GridData_5);

        
        lCommand.setLayoutData(GridData_44);
        lCommand.setText("Browser command (use %url wildcard):");
        edBrowserLaunch.setLayoutData(GridData_55);
        
        gPlugins.setLayoutData(GridData_7);
        gPlugins.setText(" Plugins");
        lActivate.setLayoutData(GridData_12);
        lActivate.setText("Add or remove plugins.");
        tablePlugins.setLayoutData(GridData_8);
        tablePlugins.setLinesVisible(true);
        tablePlugins.setHeaderVisible(true);
        colPlugins.setText("Plugins");
        panPluginButtons.setLayoutData(new GridData());
        btnAdd.setLayoutData(GridData_9);
        btnAdd.setText("Add");
        btnRemove.setLayoutData(GridData_10);
        btnRemove.setText("Remove");
        panPluginButtons.setLayout(GridLayout_4);
        gPlugins.setLayout(GridLayout_3);
        gOptions.setLayout(GridLayout_2);
        parent.setLayout(new GridLayout());
        
        //TODO: add implementation here
        String [] items = {"Not implemented yet"};
        new TableItem(tablePlugins, SWT.DEFAULT).setText(items);
        
        //gPlugins.setEnabled(false);
        //lActivate.setEnabled(false);
        tablePlugins.setEnabled(false);
        btnAdd.setEnabled(false);
        btnRemove.setEnabled(false);
        // END VISUALS_INITIALIZATION
        
        // START EVENT_INITIALIZATION
        
        // END EVENT_INITIALIZATION
        
        
        parent.layout();
    }
    
    // START EVENT_HANDLING
    private InputStream getImageResourceAsStream(String name) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    // END EVENT_HANDLING
    
    public GeneralSettings(Composite parent) {
        createControls(parent);
    }
    

    public void setRememberText(boolean set){
        chkRemmember.setSelection(set);
    }

    public void setScanAndReverse(boolean set){
        chkScanAndReverse.setSelection(set);
    }
    public void setSendAllErrors(boolean set){
        chkInformDevelopers.setSelection(set);
    }
    public void setBrowserLaunch(String command){
        edBrowserLaunch.setText(command);
    }
    public void setTimeout(String timeOut){
        edTimeout.setText(timeOut);
    }

    public boolean getRememberText(){
        return chkRemmember.getSelection();
    }

    public boolean getScanAndReverse(){
        return chkScanAndReverse.getSelection();
    }
    public boolean getSendAllErrors(){
        return chkInformDevelopers.getSelection();
    }
    public String getBrowserLaunch(){
        return edBrowserLaunch.getText();
    }
    public String getTimeout(){
        return edTimeout.getText();
    }
       
}


