package com.softsky.transj.ui.swt;
import java.io.InputStream;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import java.util.*;

import com.softsky.transj.translator.Language;

public class LanguagesSettings {
    // START VISUALS_DECLARATION
    //private Display display = null;
    private TableItem tiLanguage = null;
    //private Shell parent = null;
    private TableColumn colLanguage = null;
    private Table tableLanguages = null;
    private Composite panBottom = null;
    private Button btnCheckAll = null;
    private Button btnUnCheckAll = null;
    // END VISUALS_DECLARATION
    
    private void createControls(Composite parent) {
        // START VISUALS_INITIALIZATION
        // init visuals
        //parent = new Shell(display, SWT.DEFAULT);
        
        // set properties
        //parent.setBounds(new Rectangle(402, 438, 468, 272));
        
        GridData GridData_0 = new GridData();
        GridData GridData_1 = new GridData();
        GridData GridData_2 = new GridData();
        GridLayout GridLayout_1 = new GridLayout();
        
        GridData_0.grabExcessHorizontalSpace = true;
        GridData_0.grabExcessVerticalSpace = false;
        
        GridData_1.grabExcessHorizontalSpace = true;
        GridData_1.grabExcessVerticalSpace = true;
        GridData_1.horizontalAlignment = GridData.FILL;
        GridData_1.verticalAlignment = GridData.FILL;
        
        GridData_2.grabExcessHorizontalSpace = true;
        GridData_2.grabExcessVerticalSpace = true;
        GridData_2.horizontalAlignment = GridData.FILL;
        GridData_2.verticalAlignment = GridData.FILL;
        GridData_2.widthHint = 30;
        
        
        Label lCaptionText = new Label(parent, SWT.WRAP);
        lCaptionText.setLayoutData(GridData_0);
        lCaptionText.setText("If you use only several languages often, please check them.\nOnly these lanuages will appear in Directions list.");
        
        tableLanguages = new Table(parent, SWT.SINGLE | SWT.BORDER | SWT.CHECK | SWT.FULL_SELECTION);
        colLanguage = new TableColumn(tableLanguages, SWT.LEFT);
        tableLanguages.setLinesVisible(true);
        tableLanguages.setHeaderVisible(true);
        colLanguage.setWidth(300);
        colLanguage.setResizable(true);
        colLanguage.setText("Active Languages");
        parent.setLayout(GridLayout_1);
        tableLanguages.setLayoutData(GridData_1);
        
        panBottom = new Composite(parent, SWT.NONE);
        panBottom.setLayoutData(GridData_2);
        GridLayout GridLayout_2 = new GridLayout();
        GridLayout_2.numColumns = 2;
        panBottom.setLayout(GridLayout_2);
        btnCheckAll = new Button(panBottom, SWT.NONE);
        btnCheckAll.setText("Select all");
        btnUnCheckAll = new Button(panBottom, SWT.NONE);
        btnUnCheckAll.setText("Unselect all");
        // END VISUALS_INITIALIZATION
        
        // START EVENT_INITIALIZATION
        btnCheckAll.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                checkAllItems(true);
            }
            
        });
        btnUnCheckAll.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                checkAllItems(false);
            }
            
        });
        // END EVENT_INITIALIZATION
        
        //parent.layout();
    }
    private void checkAllItems(boolean setCheck){
        TableItem [] items = tableLanguages.getItems();
        for(int a=0;a<items.length;a++){
            items[a].setChecked(setCheck);
        }
    };
    
    // START EVENT_HANDLING
    private InputStream getImageResourceAsStream(String name) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    // END EVENT_HANDLING
    
    public LanguagesSettings(Composite parent) {
        createControls(parent);
    }
    
    public void addLanguage(Language lang, boolean checked){
        tiLanguage = new TableItem(tableLanguages, SWT.NULL);
        tiLanguage.setText(lang.getFullName());
        tiLanguage.setChecked(checked);
        tiLanguage.setGrayed(false);
    }
    
    public boolean isLanguageActive(Language lang){
        TableItem [] items = tableLanguages.getItems();
        for(int a=0;a<items.length;a++){
            if(items[a].getText().equals(lang.getFullName()))
                return items[a].getChecked();
        }
        return false;
    }
}


