package com.softsky.transj.ui.swt;

import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import java.io.*;
import java.net.*;
import java.util.*;
import com.softsky.transj.translator.*;
import com.softsky.transj.TransJ;
import com.softsky.transj.ui.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.internal.*;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.FillLayout;
import com.softsky.transj.ui.IMainWindow;
import com.softsky.transj.IExceptionHandler;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.browser.*;
import org.eclipse.swt.widgets.TrayItem;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.events.*;

public class MainWindow extends WindowWithState implements ITranslationCallback, IMainWindow, IOptionsMonitor, IExceptionHandler {
    // START VISUALS_DECLARATION
    private Label lWords = null;
    private Menu popupMenu = null;
    private Menu directionsMenu = null;
    private Menu trayPopupMenu = null;
    private Combo cbWords = null;
    private Label lTranslation = null;
    private Text edTranslated = null;
    private Button btnDirection = null;
    private Display display = null;
    private MenuItem miHelpOnlineFAQ = null;
    private Button btnTranslate = null;
    private Label lBanner = null;
    
    private ITranslator translator = null;
    private IExceptionHandler exceptionHandler = null;
    private TrayItem trayItem = null;
    private Image defaultImage = null;
    private SettingsWindow settingsWindow = null;
    public boolean quitting = false;
    
    private Options options = null;
    private Image [] animatedImages = null;
    private boolean translationInProcess = false;
    private int image_index = 0;
    private String szTranslated = "";
    private boolean animationLoopActive = false;
    private boolean alreadyReversed = false;
    // END VISUALS_DECLARATION
    
    private void createControls( ) {
        // START VISUALS_INITIALIZATION
        // init visuals
        display = Display.getDefault();
        createShell(display, SWT.MODELESS | SWT.SHELL_TRIM);
        Shell shell = getShell();
        lWords = new Label(shell, SWT.CENTER);
        cbWords = new Combo(shell, SWT.DROP_DOWN);
        lTranslation = new Label(shell, SWT.CENTER);
        edTranslated = new Text(shell, SWT.BORDER | SWT.READ_ONLY | SWT.MULTI | SWT.WRAP);
        btnDirection = new Button(shell, SWT.PUSH);
        btnTranslate = new Button(shell, SWT.PUSH);
        //lBanner = new Label(shell, SWT.CENTER);
        
        // init nonviusuals
        GridData GridData_1 = new GridData();
        GridData GridData_2 = new GridData();
        GridData GridData_4 = new GridData();
        GridData GridData_5 = new GridData();
        GridData GridData_7 = new GridData();
        GridData GridData_8 = new GridData();
        GridLayout GridLayout_1 = new GridLayout();
        
        // set fields
        GridData_1.grabExcessVerticalSpace = false;
        GridData_1.grabExcessHorizontalSpace = false;
        GridData_2.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_2.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_2.grabExcessVerticalSpace = false;
        GridData_2.widthHint = -1;
        GridData_2.grabExcessHorizontalSpace = true;
        GridData_4.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_4.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_4.widthHint = -1;
        GridData_4.grabExcessVerticalSpace = true;
        GridData_5.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_5.heightHint = -1;
        GridData_5.widthHint = -1;
        GridData_5.grabExcessHorizontalSpace = true;
        GridData_7.verticalSpan = 1;
        GridData_7.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_7.grabExcessVerticalSpace = false;
        GridData_7.widthHint = -1;
        GridData_7.horizontalSpan = 2;
        GridData_7.grabExcessHorizontalSpace = false;
        GridData_7.horizontalIndent = 0;
        GridLayout_1.numColumns = 2;
        GridData_8.horizontalSpan = 2;
        GridData_8.heightHint = 31;
        GridData_8.grabExcessHorizontalSpace = true;
        GridData_8.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        
        // set properties
        getShell().setText("TransJ");
        getShell().setBounds(new Rectangle(200, 200, 350, 200));
        lWords.setLayoutData(GridData_1);
        lWords.setText("Word(s)");
        cbWords.setLayoutData(GridData_2);
        cbWords.setVisibleItemCount(4);
        lTranslation.setLayoutData(new GridData());
        lTranslation.setText("Translation");
        edTranslated.setLayoutData(GridData_4);
        btnDirection.setLayoutData(new GridData());
        btnDirection.setText("&Direction");
        btnTranslate.setLayoutData(GridData_5);
        btnTranslate.setText("&Translate!");
        
        //lBanner.setVisible(true);
        //lBanner.setLayoutData(GridData_8);
        
        getShell().setLayout(GridLayout_1);
        //getShell().setVisible(true);
        getShell().addShellListener(new ShellAdapter(){
            public void shellClosed(ShellEvent e){
                e.doit = quitting;
                getShell().setVisible(false);
            }
        });
        // END VISUALS_INITIALIZATION
        
        // START EVENT_INITIALIZATION
        
        cbWords.addKeyListener(new KeyAdapter(){
            public void keyPressed(KeyEvent e){
                if(e.keyCode == SWT.CR) {// check if Enter was pressed
                    btnTranslate_widgetSelected(null);
                }
                super.keyPressed(e);
            }
        });
        btnDirection.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                btnDirection_widgetSelected(e);
            }
        });
        
        btnTranslate.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                btnTranslate_widgetSelected(e);
            }
        });
        
        getShell().addKeyListener(new org.eclipse.swt.events.KeyAdapter() {
            public void keyPressed(KeyEvent e){
                if(e.keyCode == SWT.CR) {// check if Enter was pressed
                    btnTranslate_widgetSelected(null);
                }
                super.keyPressed(e);
            }
        }
        );
        
        
        // END EVENT_INITIALIZATION
    }
    
    // START EVENT_HANDLING
    public void btnDirection_widgetSelected( SelectionEvent e ) {
        popupMenu.setVisible(true);
    }
    public void btnTranslate_widgetSelected( SelectionEvent e ) {
        if(options.getDirection() == null) {
            MessageBox box = new MessageBox(getShell(), SWT.ICON_ERROR);
            box.setMessage("You must specify translation direction first!");
            box.setText("Information");
            box.open();
            popupMenu.setVisible(true);
        }
        else {
            alreadyReversed = false;
            setStatus("Translating text ...");
            translate();
        }
    }
    private InputStream getImageResourceAsStream( String name ) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    public void miHelpAbout_widgetSelected( SelectionEvent e ) {
        //System.out.println("miHelpAbout_widgetSelected: " + e );
        new About(getShell(), this).open();
    }
    // END EVENT_HANDLING
    
    public MainWindow() {
        super();
        animatedImages = new Image[8];
        for(int a=0;a<animatedImages.length;a++)
            animatedImages[a] = new Image(display, getImageResourceAsStream("com/softsky/transj/images/ico" + getDefaultImageSize() + "_" + a + ".gif"));
    }
    
    private void createDirections(Menu menu) {
        Direction [] directions = translator.getSupportedDirections();
        for(int a=0;a<directions.length;a++) {
            Direction direction = directions[a];
            // if any language is active in this direction
            if(options != null)
                if(options.isLanguageActive(direction.getFromLanguage()) && options.isLanguageActive(direction.getToLanguage())) {
                    // add direction
                    MenuItem miDirection = new MenuItem(menu, SWT.RADIO);
                    miDirection.setText(direction.toString());
                    miDirection.setData(direction);
                    miDirection.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                        public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                            MenuItem mi = (MenuItem)e.getSource();
                            Direction direction = (Direction)mi.getData();
                            options.setDirection(direction);
                            setDirection(direction);
                        }
                    });
                }
        }
    }
    private void createPopupMenu( ) {
        popupMenu = new Menu(getShell(), SWT.POP_UP);
        createDirections(popupMenu);
    }
    private void createTrayPopupMenu( ) {
        trayPopupMenu = new Menu(getShell(), SWT.POP_UP);
        MenuItem miDirections = new MenuItem(trayPopupMenu, SWT.CASCADE);
        directionsMenu = new Menu(miDirections);
        miDirections.setMenu(directionsMenu);
        new MenuItem(trayPopupMenu, SWT.SEPARATOR);
        MenuItem miAbout = new MenuItem(trayPopupMenu, SWT.CASCADE);
        MenuItem miOnlineFAQ = new MenuItem(trayPopupMenu, SWT.CASCADE);
        MenuItem miCheckForUpdates = new MenuItem(trayPopupMenu, SWT.CASCADE | SWT.BOLD);
        new MenuItem(trayPopupMenu, SWT.SEPARATOR);
        MenuItem miSettings = new MenuItem(trayPopupMenu, SWT.CASCADE);
        new MenuItem(trayPopupMenu, SWT.SEPARATOR);
        MenuItem miExit = new MenuItem(trayPopupMenu, SWT.CASCADE);
        
        miDirections.setText("Directions");
        createDirections(directionsMenu);
        
        miAbout.setText("&About");
        miOnlineFAQ.setText("&Online FAQ");
        //miOnlineFAQ.setImage(new Image(getDisplay(), getImageResourceAsStream("com/softsky/transj/images/onlinefaq" + getDefaultImageSize() + ".gif")));
        miCheckForUpdates.setText("&Check for Updates");
        miSettings.setText("&Settings...");
        //miSettings.setImage(new Image(getDisplay(), getImageResourceAsStream("com/softsky/transj/images/settings" + getDefaultImageSize() + ".gif")));
        miExit.setText("E&xit");
        
        miSettings.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                openSettings();
            }
        });
        miExit.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                quitting = true;
                getShell().close();
            }
        });
        
        miAbout.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                //miHelpAbout_widgetSelected(e); //TODO change to actual about window
                try{
                    //TODO: Change right FAQ page url
                    String url = "http://www.softsky.biz/?app";
                    String szCommand = options.getBrowserLaunch();
                    szCommand = szCommand.replaceFirst("%url", url);
                    Runtime.getRuntime().exec(szCommand);
                    
                }catch(IOException ex){exceptionHandler.handleException(ex);}
            }
        });
        
        miOnlineFAQ.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                /*
                Browser browser = new Browser(getShell(), SWT.NONE);
                browser.setUrl("http://www.softsky.com.ua");
                 **/
                try{
                    String url = "http://www.softsky.biz/cocoon/?section=transj_faq&app";
                    String szCommand = options.getBrowserLaunch();
                    szCommand = szCommand.replaceFirst("%url", url);
                    Runtime.getRuntime().exec(szCommand);
                    
                }catch(IOException ex){exceptionHandler.handleException(ex);}
            }
        });
        
        miCheckForUpdates.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                new Thread(){
                    public void run(){
                        checkNewVersionAndFire();
                    }
                }.start();
            }
        });
        
    }
    /**
     * Getter for property direction.
     * @return Value of property direction.
     */
    
    
    private void checkOnDirection(Direction direction, Menu menu){
        String szDirection = direction.toString();
        for(int a=0;a<menu.getItemCount();a++){
            MenuItem mi = menu.getItem(a);
            if(mi.getText().equals(szDirection))
                mi.setSelection(true);
            else
                mi.setSelection(false);
        }
    }
    
    
    /**
     * Getter for property display.
     * @return Value of property display.
     */
    private Display getDisplay( ) {
        return display;
    }
    
    
    private void setStatus( String statusMessage ) {
        edTranslated.setText(statusMessage);
    }
    
    public void translationDone( TranslationResult translationResult ) {
        szTranslated = translationResult.toString();
        try{
            display.asyncExec(new Runnable(){
                public void run(){
                    if(szTranslated.equals(cbWords.getText())){
                        if(options.isScanAndReverse() && (alreadyReversed == false)){
                            alreadyReversed = true;
                            swapDirection();
                            setStatus("Trying with changed direction...");
                            translate();
                        }else {
                            edTranslated.setText(szTranslated);
                        }
                    }
                    else{
                        edTranslated.setText(szTranslated);
                    }
                }
            });
        }catch(Exception e){
            
        }
        translationInProcess = false;
    }
    
    
    public void initialize(ITranslator translator, IExceptionHandler exceptionHandler ) {
        this.translator = translator;
        this.exceptionHandler = exceptionHandler;
        
        createControls();
        createPopupMenu();
        createTrayPopupMenu();
        getShell().layout();
        
        //startBannerRotation();
        
        defaultImage =  new Image(display, getImageResourceAsStream("com/softsky/transj/images/ico" + getDefaultImageSize() + "_0.gif"));
        //defaultImage = new Image(display, defaultImage.getImageData().scaledTo(24, 24));
        
        getShell().setImage(defaultImage);
        createTrayItem();
        cbWords.setFocus();
        
    }
    
    public void handleException(final Exception e) {
        Display.getDefault().asyncExec(new Runnable(){
            public void run(){
                ExceptionWindow ew = new ExceptionWindow(getShell(), e);
                ew.open();
            }
        });
        //e.printStackTrace();
    }
    
    public void run() {
        final Shell shell = getShell();
        shell.open();
        display = Display.getDefault();
        new Thread(){
            public void run(){
                if(checkNewVersionPublished(null))
                    checkNewVersionAndFire();
            }
        }.start();
        
        while (!getShell().isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }
        display.dispose();
    }
    private void createTrayItem( ){
        Tray tray = display.getSystemTray();
        trayItem = new TrayItem(tray, SWT.DEFAULT);
        trayItem.setImage(defaultImage);
        trayItem.setToolTipText("TransJ - multilingual desktop translation tool");
        
        trayItem.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                /*
                if(false){ // TODO: fix here. It does not work properly on Windows for some reason.
                    if(display.getActiveShell() == getShell())
                        getShell().setVisible(!getShell().getVisible());
                    else {
                        getShell().setVisible(false);
                        getShell().setVisible(true);
                        getShell().forceActive();
                    }
                } else {
                    Shell shell = getShell();
                    shell.setVisible(!shell.getVisible());
                    shell.forceActive();
                };
                 */
                Shell shell = getShell();
                shell.setVisible(!shell.getVisible());
                shell.forceActive();
                
            }
        });
        trayItem.addListener(SWT.MenuDetect, new Listener() {
            public void handleEvent(Event event) {
                trayPopupMenu.setVisible(true);
            }
        });
    }
    
    private void openSettings() {
        Shell shell = getShell();
        shell.setVisible(false);
        shell.setVisible(true);
        settingsWindow = new SettingsWindow(getShell(), "com/softsky/transj/images/ico" + getDefaultImageSize() + "_0.gif", this, options);
        settingsWindow.open();
    }
    
    /**
     * Getter for property options.
     * @return Value of property options.
     */
    public com.softsky.transj.ui.swt.Options getOptions() {
        return options;
    }
    
    /**
     * Setter for property options.
     * @param options New value of property options.
     */
    public void setOptions(com.softsky.transj.ui.swt.Options options) {
        this.options = options;
        
        optionsChanged(options);
        Direction direction;
        if((options != null) && ((direction = options.getDirection()) != null)) {
            setDirection(direction);
        };
    }
    
    private void setDirection(Direction direction){
        checkOnDirection(direction, popupMenu);
        checkOnDirection(direction, directionsMenu);
        btnDirection.setText(direction.getFromLanguage().getShortName() + " -> " + direction.getToLanguage().getShortName());
        getShell().layout();
        translator.clearCache();
    }
    
    public void optionsChanged(Options options) {
        this.options = options;
        createPopupMenu();
        createTrayPopupMenu();
        setDirection(options.getDirection());
    }
    private String getDefaultImageSize(){
        String imageName = "24x24";
        
        if(TransJ.OSNAME.indexOf("Windows") > -1)
            imageName = "16x16";
        
        return imageName;
    }
    private void swapDirection(){
        Direction direction = options.getDirection();
        options.setDirection(new Direction(direction.getToLanguage(), direction.getFromLanguage()));
        setDirection(options.getDirection());
    }
    
    public void translate(){
        String text = cbWords.getText();
        String [] words = cbWords.getItems();
        int a;
        for(a=0;a<words.length;a++)
            if(words[a].equals(text))
                break;
        if(a == words.length) //nothing was found
            cbWords.add(text);
        
        //InputStream is = getImageResourceAsStream("com/softsky/transj/images/translating.gif");
        //trayItem.setImage(new Image(display, is));
        translationInProcess = true;
        new Thread(){
            public void run(){
                image_index = 0;
                if(!animationLoopActive){
                    try{
                        animationLoopActive = true;
                        while(!getDisplay().isDisposed()){
                            try{
                                display.syncExec(new Runnable(){
                                    public void run(){
                                        try{
                                            trayItem.setImage(animatedImages[image_index++]);
                                        }catch(Exception e){
                                            
                                        }
                                    }
                                });
                                if((image_index == 1) && (false == translationInProcess))
                                    break;
                                Thread.sleep(100);
                                if(image_index > 7)
                                    image_index = 0;
                            }catch(InterruptedException e){
                                handleException(e);
                            }
                        };
                    }finally{
                        animationLoopActive = false;
                    }
                };
            }
        }.start();
        
        new Thread(new TranslationProcess(this, translator, options, options.getDirection(), text)).start();
    }
    
    private void checkNewVersionAndFire(){
        final StringBuffer netVersion = new StringBuffer();
        if(checkNewVersionPublished(netVersion)){
            try{
                display.asyncExec(new Runnable(){
                    public void run(){
                        String messageText = "TransJ version " + netVersion + " is available for download";
                        MessageBox mb = new MessageBox(getShell(), SWT.ICON_INFORMATION);
                        mb.setText("Information");
                        mb.setMessage(messageText);
                        mb.open();
                    }
                });
                
                String url = "http://www.softsky.biz/cocoon/?section=opensource&id=1&app";
                String szCommand = options.getBrowserLaunch();
                szCommand = szCommand.replaceFirst("%url", url);
                Runtime.getRuntime().exec(szCommand);
                
            }catch(IOException ex){exceptionHandler.handleException(ex);}
        }
        else {
            display.asyncExec(new Runnable(){
                public void run(){
                    String messageText = "No new versions available";
                    MessageBox mb = new MessageBox(getShell(), SWT.ICON_INFORMATION);
                    mb.setText("Information");
                    mb.setMessage(messageText);
                    mb.open();
                }
            });
        }
    }
    
    private void startBannerRotation(){
        new Thread(){
            public void run(){
                final Vector images = new Vector();
                images.add("http://www.softsky.com.ua/images/logo/it_logo_88_31_1.gif");
                images.add("http://www.softsky.com.ua/images/logo/opensource.gif");
                images.add("http://www.softsky.com.ua/images/logo/sflogo.gif");
                images.add("http://www.softsky.com.ua/images/logo/opensource.gif");
                int bannerIndex = 0;
                while(!getDisplay().isDisposed()){
                    try{
                        final Image bannerImage = new Image(getDisplay(), new URL((String)images.get(bannerIndex)).openConnection().getInputStream());
                        bannerIndex += 1;
                        bannerIndex &= 3;
                        getDisplay().asyncExec(new Runnable(){
                            public void run(){
                                try{
                                    if(!lBanner.isDisposed()){
                                        lBanner.setImage(bannerImage);
                                        lBanner.update();
                                    }
                                }catch(Exception e){
                                    
                                }
                            }
                        });
                        Thread.sleep(5000);
                    }catch(Exception e){
                    }
                }
            }
        }.start();
    }
    private boolean checkNewVersionPublished(StringBuffer buffer){
        try{
            HttpURLConnection conn = (HttpURLConnection)new URL("http://www.softsky.biz/cocoon/transj-version.txt").openConnection();
            conn.connect();
            BufferedReader isr = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String netVersion = isr.readLine().trim();
            if(buffer != null){
                buffer.setLength(0);
                buffer.append(netVersion);
            }
            
            String messageText;
            int buttons = SWT.OK;
            boolean noNewVersion = netVersion.equals(TransJ.VERSION);
            return !noNewVersion;
        }catch(Exception e){
            exceptionHandler.handleException(e);
        }
        return false;
    }
}
