package com.softsky.transj.ui.swt;

import org.eclipse.swt.events.*;
import java.util.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import java.io.InputStream;
import com.softsky.transj.translator.Language;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.FillLayout;
import com.softsky.transj.ui.IMainWindow;
import com.softsky.transj.ui.IOptionsMonitor;

public class SettingsWindow extends WindowWithState {
    // START VISUALS_DECLARATION
    private TabItem tiGeneral = null;
    private TabItem tiLanguages = null;
    private Composite panGeneral = null;
    private Composite panLanguages = null;
    private TabFolder tabFolder = null;
    private Composite panBottom = null;
    private Label lLogo = null;
    private Button btnCancel = null;
    private Button btnOK = null;
    private Display display = null;
    private Shell parent = null;
    private Image windowIcon = null;
    private Options options = null;
    // END VISUALS_DECLARATION
    
    private GeneralSettings generalSettings = null;
    private LanguagesSettings languageSettings = null;
    private IOptionsMonitor optionsMonitor;
    
    private void createControls( ) {
        // START VISUALS_INITIALIZATION
        // init visuals
        display = parent.getDisplay();
        createShell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL | SWT.CENTER);
        Shell shell = getShell();
        lLogo = new Label(shell, SWT.CENTER);
        tabFolder = new TabFolder(shell, SWT.NULL);
        panGeneral = new Composite(tabFolder, SWT.NULL);
        panLanguages = new Composite(tabFolder, SWT.NULL);
        tiGeneral = new TabItem(tabFolder, SWT.DEFAULT);
        tiLanguages = new TabItem(tabFolder, SWT.DEFAULT);
        panBottom = new Composite(shell, SWT.NULL);
        btnOK = new Button(panBottom, SWT.PUSH);
        btnCancel = new Button(panBottom, SWT.PUSH);
        
        // init nonviusuals
        GridData GridData_5 = new GridData();
        GridData GridData_1 = new GridData();
        GridData GridData_3 = new GridData();
        GridData GridData_4 = new GridData();
        GridData GridData_2 = new GridData();
        GridLayout GridLayout_2 = new GridLayout();
        GridLayout GridLayout_1 = new GridLayout();
        
        // set fields
        GridData_5.horizontalAlignment = org.eclipse.swt.layout.GridData.CENTER;
        GridData_5.heightHint = 500;
        GridData_5.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
        GridData_5.grabExcessVerticalSpace = true;
        GridData_5.widthHint = 100;
        GridData_1.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_1.heightHint = 300;
        GridData_1.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
        GridData_1.grabExcessVerticalSpace = true;
        GridData_1.widthHint = 500;
        GridData_1.grabExcessHorizontalSpace = true;
        GridData_3.horizontalAlignment = org.eclipse.swt.layout.GridData.BEGINNING;
        GridData_3.verticalAlignment = org.eclipse.swt.layout.GridData.END;
        GridData_3.widthHint = 75;
        GridData_4.horizontalAlignment = org.eclipse.swt.layout.GridData.END;
        GridData_4.widthHint = 75;
        GridData_2.horizontalAlignment = org.eclipse.swt.layout.GridData.END;
        GridData_2.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
        GridData_2.horizontalSpan = 2;
        GridData_2.grabExcessHorizontalSpace = true;
        GridLayout_2.numColumns = 2;
        GridLayout_1.marginHeight = 5;
        GridLayout_1.numColumns = 2;
        
        // set properties
        shell.setImage(windowIcon);
        shell.setText("Settings");
        lLogo.setImage(new Image(display, getImageResourceAsStream("com/softsky/transj/images/transjsettings.jpg")));
        lLogo.setLayoutData(GridData_5);
        tabFolder.setLayoutData(GridData_1);
        tiGeneral.setText("Genaral");
        tiGeneral.setControl(panGeneral);
        tiLanguages.setText("Languages");
        tiLanguages.setControl(panLanguages);
        
        panBottom.setLayoutData(GridData_2);
        btnOK.setLayoutData(GridData_3);
        btnOK.setText("OK");
        btnCancel.setLayoutData(GridData_4);
        btnCancel.setText("Cancel");
        panBottom.setLayout(GridLayout_2);
        shell.setLayout(GridLayout_1);
        
        shell.setDefaultButton(btnOK);

        shell.addShellListener(new ShellAdapter(){
            public void shellClosed(ShellEvent e){
                if(true)
                    e.doit = true;
                else
                    e.doit = false;
                    getShell().setVisible(false);
            }
        });
        // END VISUALS_INITIALIZATION
        
        btnOK.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(SelectionEvent e){
                options.setRememberText(generalSettings.getRememberText());
                options.setScanAndReverse(generalSettings.getScanAndReverse());
                options.setSendAllErrors(generalSettings.getSendAllErrors());
                try{
                options.setTimeout(Integer.parseInt(generalSettings.getTimeout()));
                }catch(Exception ex){
                    e.doit = false;
                    MessageBox mb =new MessageBox(getShell(), SWT.ICON_ERROR);
                    mb.setMessage("Connection timeout should be integer value!");
                    mb.open();
                }
                options.setBrowserLaunch(generalSettings.getBrowserLaunch());
                
                Enumeration langs = Language.getAllLanguages();
                while(langs.hasMoreElements()){
                    Language lang = (Language)langs.nextElement();
                    boolean isActive = languageSettings.isLanguageActive(lang);
                    options.setLanguageActive(lang, isActive);
                }
                optionsMonitor.optionsChanged(options);
                getShell().close();
            }
        });

        btnCancel.addSelectionListener(new SelectionAdapter(){
            public void widgetSelected(SelectionEvent e){
                getShell().close();
            }
        });
        
    }
    
    // START EVENT_HANDLING
    private InputStream getImageResourceAsStream( String name ) {
        // enable image loading from jars
        return getClass().getResourceAsStream("/" + name);
    }
    // END EVENT_HANDLING
    
    public SettingsWindow( Shell parent, String iconResource, IOptionsMonitor optionsMonitor, Options options ) {
        windowIcon = new Image(display, getImageResourceAsStream(iconResource));
        this.optionsMonitor = optionsMonitor;
        this.options = options;
        this.parent = parent;
        createControls();
        generalSettings = new GeneralSettings(panGeneral);
        languageSettings = new LanguagesSettings(panLanguages);
        
        generalSettings.setRememberText(options.isRememberText());
        generalSettings.setScanAndReverse(options.isScanAndReverse());
        generalSettings.setSendAllErrors(options.isSendAllErrors());
        
        generalSettings.setTimeout(Integer.toString(options.getTimeout()));
        generalSettings.setBrowserLaunch(options.getBrowserLaunch());
        
        Enumeration langs = options.getAllLanguages();
        while(langs.hasMoreElements()){
            Language lang = (Language)langs.nextElement();
            languageSettings.addLanguage(lang, options.isLanguageActive(lang));
        }
        
    }
    
    public void open( ) {
        Shell shell = getShell();            
        shell.layout();
        shell.pack();
        shell.open();
        shell.forceActive();
    }    
    
    /**
     * Getter for property generalSettings.
     * @return Value of property generalSettings.
     */
    public GeneralSettings getGeneralSettings( ) {
        return generalSettings;
    }
    /**
     * Getter for property languageSettings.
     * @return Value of property languageSettings.
     */
    public LanguagesSettings getLanguageSettings( ) {
        return languageSettings;
    }
    
}
