/**
 * @(#) WindowWithState.java
 */

package com.softsky.transj.ui.swt;

import org.eclipse.swt.graphics.*;
import java.io.*;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.widgets.*;


public class WindowWithState{
    private Shell shell = null;
    
    private WindowState windowState = new WindowState();
    
    public Shell getShell( ) {
        return shell;
    }
    
    
    public void createShell( Display display, int attrs ) {
        shell = new Shell(display, attrs);
        setupCallback();
    }
    
    public void createShell( Shell parentShell, int attrs ) {
        shell = new Shell(parentShell, attrs);
        setupCallback();
    }
    
    private void setupCallback(){
        shell.addControlListener(new ControlAdapter(){
            public void controlResized(ControlEvent e){
                windowState.setBounds(shell.getBounds());
            }
            public void controlMoved(ControlEvent e){
                windowState.setBounds(shell.getBounds());
            }
        });
    }
    
        /*
    public void readFrom( ObjectInputStream in ) {
        try{
            WindowState ws = (WindowState)in.readObject();
            if(ws != null){
                windowState = ws;
                applyState();
            }
        }catch(IOException e){e.printStackTrace();}
        catch(ClassNotFoundException e){e.printStackTrace();}
         
    }
         */
    
    /**
     * Getter for property windowState.
     * @return Value of property windowState.
     */
    public com.softsky.transj.ui.swt.WindowState getWindowState() {
        return windowState;
    }
    
    /**
     * Setter for property windowState.
     * @param windowState New value of property windowState.
     */
    public void setWindowState(com.softsky.transj.ui.swt.WindowState windowState) {
        if(windowState != null){
            this.windowState = windowState;
            Shell shell = getShell();
            if(null != shell)
                shell.setBounds(windowState.getBounds());
        }
    }
    
}
